pmarlen-web/src/main/java/com/pmarlen/web/operation/OperacionesEnAlmacenesMB.java
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.pmarlen.web.operation;

import com.pmarlen.businesslogic.LogicaFinaciera;
import com.pmarlen.businesslogic.PedidoVentaBusinessLogic;
import com.pmarlen.model.Constants;
import com.pmarlen.model.beans.*;
import com.pmarlen.model.controller.PedidoVentaJpaController;
import com.pmarlen.model.controller.ProductoJpaController;
import com.pmarlen.model.dto.MovimientoEntreAlmacenes;
import com.pmarlen.model.dto.ProductoEnTrancito;
import com.pmarlen.web.security.managedbean.SessionUserMB;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.faces.validator.ValidatorException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.springframework.beans.factory.annotation.Autowired;

/**
 *
 * @author VEAXX9M
 */
public class OperacionesEnAlmacenesMB {

	@Autowired
	private ProductoJpaController productoJpaController;
	@Autowired
	private PedidoVentaBusinessLogic pedidoVentaBusinessLogic;
	@Autowired
	private SessionUserMB sessionUserMB;
	private Integer sucursalId;
	private Logger logger;
	private int scrollerPage;

	private List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList;
	
	public OperacionesEnAlmacenesMB() {
		logger = LoggerFactory.getLogger(PedidosPreVisorMB.class);
		sucursalId = 1;
	}

	public List<SelectItem> getSucursales() {
		List<Sucursal> list = productoJpaController.findAllSucursales();
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (Sucursal s : list) {
			SelectItem sucursalSI = new SelectItem(s.getId(), s.getNombre());
			result.add(sucursalSI);
		}

		return result;
	}

	public List<SelectItem> getSucursalesHijas() {
		List<Sucursal> list = productoJpaController.findAllSucursales();
		List<SelectItem> result = new ArrayList<SelectItem>();
		for (Sucursal s : list) {
			if (s.getSucursal() == null) {
				continue;
			}
			SelectItem sucursalSI = new SelectItem(s.getId(), s.getNombre());
			result.add(sucursalSI);
		}

		return result;
	}

	private void dataValidation() throws ValidatorException {
		logger.debug("\t################################ >> dataValidation: ");
		//logger.debug("\t\t################################ >> throw new ValidatorException Cliente!");
		//throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Debe seleccionar el Cliente !!", "Debe seleccionalr el Cliente !!"));
		//throw new ValidatorException(new FacesMessage(FacesMessage.SEVERITY_ERROR, "Debe seleccionar la Forma de Pago!!", "Debe seleccionalr la Forma de Pago!!"));        
	}

	public String confirmarSurtirAlmacenPrincipal() {
		logger.debug("========================================================>>");
		logger.debug("-->>confirmarSurtirAlmacenPrincipal():");
		logger.debug("========================================================>>");
		try {

			dataValidation();
			try{
				for(MovimientoEntreAlmacenes ma:movimientoEntreAlmacenesList){
					logger.debug("\t-->>MovimientoEntreAlmacenes: Producto ["+ma.getProducto().getId()+"] surtir:"+ma.getDestinoSurtir()+" PV: $"+ma.getDestinoPV());
				}
				pedidoVentaBusinessLogic.movimientoEntreElmacenes(movimientoEntreAlmacenesList, sucursalId, Constants.ALMACEN_PRINCIPAL,sessionUserMB.getUsuarioAuthenticated());

				return null;
            } catch (Exception ex) {
                logger.debug("<<++++++++++++++++++++++++++++++++++++++++++++++++++");
                ex.printStackTrace(System.err);
                logger.debug("Error in MB confirmarSurtirAlmacen:", ex);

                throw new ValidatorException(
                        new FacesMessage(FacesMessage.SEVERITY_ERROR, ex.toString(), ex.toString()));
            } finally {
                
            }
	
        } catch (ValidatorException ve) {
            logger.debug("<<!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            FacesContext.getCurrentInstance().addMessage(
                    null,
                    ve.getFacesMessage());
            return null;
        }
	}

	public void sucursalChanged(ValueChangeEvent event) {
		Integer sucursalChanged = (Integer) event.getNewValue();
		logger.debug("-->> sucursalChanged: sucursalChanged=" + sucursalChanged);
	}

	public List<ProductoEnTrancito> getAllProductosEnTransitoDeSucursal() {
		//List<ProductoEnAlmacenesDetalle> productoEnAlmacenDetalleList = new ArrayList<ProductoEnAlmacenesDetalle>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		long t1,t2;
		
		logger.debug("==>> getAllProductosEnTransitoDeSucursal: sucursalId=" + sucursalId);		
		t1 = System.currentTimeMillis();
		List<ProductoEnTrancito> findAllProductosEnTransitoDeSucursal = productoJpaController.findAllProductosEnTransitoDeSucursal(sucursalId);
		t2 = System.currentTimeMillis();
		logger.debug("==>> T = "+(t2-t1));
		return findAllProductosEnTransitoDeSucursal;
		

	}

	public List<MovimientoEntreAlmacenes> getAllMovimientoEntreAlmacenesPrincipal() {
		//List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList = new ArrayList<MovimientoEntreAlmacenes>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getAllMovimientoEntreAlmacenes: sucursalId=" + sucursalId);
		
		movimientoEntreAlmacenesList = productoJpaController.findAllProductosMovimientoEntreAlmacenesDeSucursal(sucursalId, Constants.ALMACEN_PRINCIPAL);

		return movimientoEntreAlmacenesList;
	}

	public List<MovimientoEntreAlmacenes> getAllMovimientoEntreAlmacenesOportunidad() {
		//List<MovimientoEntreAlmacenes> movimientoEntreAlmacenesList = new ArrayList<MovimientoEntreAlmacenes>();
		//List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getAllMovimientoEntreAlmacenes: sucursalId=" + sucursalId);

		return productoJpaController.findAllProductosMovimientoEntreAlmacenesDeSucursal(sucursalId, Constants.ALMACEN_OPORTUNIDAD);
	}

	public List<ProductoEnAlmacenesDetalle> getProductosEnAlmacenes() {
		List<ProductoEnAlmacenesDetalle> productoEnAlmacenDetalleList = new ArrayList<ProductoEnAlmacenesDetalle>();
		List<Producto> productoList = productoJpaController.findAllProductoConAlmacenesDeSucursal(sucursalId);
		logger.debug("==>> getProductoConMovimientos: sucursalId=" + sucursalId);

		for (Producto producto : productoList) {
			ProductoEnAlmacenesDetalle productoEnAlmacenDetalle = new ProductoEnAlmacenesDetalle(producto);

			Collection<AlmacenProducto> almacenProductoCollection = producto.getAlmacenProductoCollection();

			logger.debug("\t==>> Producto[" + producto.getId() + "]");
			for (AlmacenProducto ap : almacenProductoCollection) {
				logger.debug("\t\t==>> AlmacenProducto: almacen=" + ap.getAlmacen() + "[" + ap.getAlmacen().getTipoAlmacen() + "],sucursal=" + ap.getAlmacen().getSucursal().getId() + ", cantidad=" + ap.getCantidadActual());
				if (ap.getAlmacen().getSucursal().getId().intValue() == sucursalId) {

					if (ap.getAlmacen().getTipoAlmacen() == Constants.ALMACEN_PRINCIPAL) {
						productoEnAlmacenDetalle.setAlmacenPrincipal(ap);
						logger.debug("\t\t\t==>> OK added");
					} else if (ap.getAlmacen().getTipoAlmacen() == Constants.ALMACEN_OPORTUNIDAD) {
						productoEnAlmacenDetalle.setAlmacenOportunidad(ap);
						logger.debug("\t\t\t==>> OK added");
					}
				}
			}
			productoEnAlmacenDetalleList.add(productoEnAlmacenDetalle);

		}

		return productoEnAlmacenDetalleList;
	}

	public void setSessionUserMB(SessionUserMB sessionUserMB) {
		this.sessionUserMB = sessionUserMB;
	}

	public void setProductoJpaController(ProductoJpaController productoJpaController) {
		this.productoJpaController = productoJpaController;
	}

	/**
	 * @return the sucursal
	 */
	public Integer getSucursalId() {
		return sucursalId;
	}

	/**
	 * @param sucursal the sucursal to set
	 */
	public void setSucursalId(Integer sucursalId) {
		this.sucursalId = sucursalId;
	}

	/**
	 * @param pedidoVentaBusinessLogic the pedidoVentaBusinessLogic to set
	 */
	public void setPedidoVentaBusinessLogic(PedidoVentaBusinessLogic pedidoVentaBusinessLogic) {
		this.pedidoVentaBusinessLogic = pedidoVentaBusinessLogic;
	}

	/**
	 * @return the scrollerPage
	 */
	public int getScrollerPage() {
		return scrollerPage;
	}

	/**
	 * @param scrollerPage the scrollerPage to set
	 */
	public void setScrollerPage(int scrollerPage) {
		this.scrollerPage = scrollerPage;
	}
}

pmarlen-web/src/main/java/com/pmarlen/web/operation/VisorProductosLineaMarcaMB.java
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.pmarlen.web.operation;

import com.pmarlen.model.beans.Linea;
import com.pmarlen.model.beans.Marca;
import com.pmarlen.model.beans.Producto;
import com.pmarlen.model.controller.LineaJpaController;
import com.pmarlen.model.controller.MarcaJpaController;
import com.pmarlen.model.controller.ProductoJpaController;
import com.pmarlen.web.common.view.messages.Messages;
import java.util.ArrayList;
import java.util.List;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.springframework.beans.factory.annotation.Autowired;

/**
 *
 * @author VEAXX9M
 */
public class VisorProductosLineaMarcaMB {

    @Autowired
    private ProductoJpaController productoJpaController;
    @Autowired
    private MarcaJpaController marcaJpaController;
    @Autowired
    private LineaJpaController lineaJpaController;
    @Autowired
    private PedidoNuevoMB pedidoNuevoMB;

    private Integer lineaSelectedId;
    private Integer marcaSelectedId;
    private Integer productoSelectedId;

    private List<Marca> marcaFilteredList;
    private List<Producto> productoFilteredList;

    private final Logger logger = LoggerFactory.getLogger(VisorProductosLineaMarcaMB.class);

    public VisorProductosLineaMarcaMB() {
        resetViewPage();
    }

    private void resetViewPage() {
        resetSlectionsBeans();
    }

    private void resetSlectionsBeans() {        
        lineaSelectedId       = null;
        marcaSelectedId         = null;
        productoSelectedId      = null;
        productoFilteredList    = new ArrayList<Producto>();
        marcaFilteredList       = new ArrayList<Marca>();
    }
    
    public void lineaChanged(ValueChangeEvent event) {
        Integer lineaNewValue = (Integer) event.getNewValue();
        logger.debug("-->> lineaChanged: lineaNewValue="+lineaNewValue);
        
        marcaSelectedId         = null;
        productoSelectedId      = null;
        productoFilteredList    = new ArrayList<Producto>();
        if(lineaNewValue != null){
            marcaFilteredList = marcaJpaController.findMarcaEntitiesByLinea(new Linea(lineaNewValue));
        } else {
            marcaFilteredList = new ArrayList<Marca>();
        }
    }
    
    public void marcaChanged(ValueChangeEvent event) {
        Integer marcaNewValue = (Integer) event.getNewValue();
        logger.debug("-->> marcaChanged: marcaNewValue="+marcaNewValue);
        if(marcaNewValue != null){
            productoFilteredList = productoJpaController.findProductoEntitiesByMarca(new Marca(marcaNewValue));
        } else {
            productoFilteredList = new ArrayList<Producto>();
        }
        productoSelectedId      = null;
    }

    public List<SelectItem> getLineaList() {

        List<SelectItem> itemsList = new ArrayList<SelectItem>();
        List<Linea> list = lineaJpaController.findLineaEntities();
        logger.debug("-->> getLineaList: ");

        itemsList.add(new SelectItem(null, Messages.getLocalizedString("COMMON_SELECTONEITEM")));

        for (Linea linea : list) {
            itemsList.add(new SelectItem(linea.getId(), linea.getNombre()));
        }
        return itemsList;
    }

    public List<SelectItem> getMarcaList() {
        List<SelectItem> itemsList = new ArrayList<SelectItem>();
        
        logger.debug("-->> getMarcaList: lineaSelectedId=" + lineaSelectedId);
        itemsList.add(new SelectItem(null, Messages.getLocalizedString("COMMON_SELECTONEITEM")));

        for (Marca marca : marcaFilteredList) {
            itemsList.add(new SelectItem(marca.getId(), marca.getNombre()));
        }
        return itemsList;
    }

    public List<Producto> getProductoList() {
        logger.debug("-->> getProductoList: marcaSelectedId=" + marcaSelectedId+"m productoFilteredList="+productoFilteredList);
        return productoFilteredList;
    }

    //--------------------------------------------------------------------------
    public void setProductoJpaController(ProductoJpaController productoJpaController) {
        this.productoJpaController = productoJpaController;
    }

    public void setMarcaJpaController(MarcaJpaController marcaJpaController) {
        this.marcaJpaController = marcaJpaController;
    }

    public void setLineaJpaController(LineaJpaController lineaJpaController) {
        this.lineaJpaController = lineaJpaController;
    }

    public void setPedidoNuevoMB(PedidoNuevoMB pedidoNuevoMB) {
        this.pedidoNuevoMB = pedidoNuevoMB;
    }
    //--------------------------------------------------------------------------
    public Integer getLineaSelectedId() {
        logger.debug("-->> getLineaSelectedId: lineaSelectedId=" + lineaSelectedId);
        return lineaSelectedId;
    }

    public void setLineaSelectedId(Integer lineaSelectedId) {
        logger.debug("-->> setLineaSelectedId: this.lineaSelectedId( "+this.lineaSelectedId+") = " + lineaSelectedId);
        this.lineaSelectedId = lineaSelectedId;
    }

    public Integer getMarcaSelectedId() {
        logger.debug("-->> getMarcaSelectedId: marcaSelectedId=" + marcaSelectedId);
        return marcaSelectedId;
    }

    public void setMarcaSelectedId(Integer marcaSelectedId) {
        logger.debug("-->> setMarcaSelectedId: this.marcaSelectedId("+this.marcaSelectedId+") = " + marcaSelectedId);
        this.marcaSelectedId = marcaSelectedId;
    }

    public Integer getProductoSelectedId() {
        return productoSelectedId;
    }

    public void setProductoSelectedId(Integer productoSelectedId) {
        this.productoSelectedId = productoSelectedId;
    }

    //--------------------------------------------------------------------------
}

pmarlen-web/src/main/webapp/pages/about.xhtml
<ui:composition	xmlns="http://www.w3.org/1999/xhtml"
				xmlns:f="http://java.sun.com/jsf/core"
				xmlns:h="http://java.sun.com/jsf/html"
				xmlns:a4j="http://richfaces.org/a4j"
				xmlns:rich="http://richfaces.org/rich"
				xmlns:ui="http://java.sun.com/jsf/facelets"
				xmlns:richx="http://xpressosystems/richx"
				template="/templates/main.xhtml">

	<ui:define name="body">
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>					
		<br/>
		<br/>
		<br/>
		<br/>					
		<div align="center">
		<h3>4e de Mexico :: Sistema de información operacional interna</h3>
		<h4>XPRESSO SYSTEMS</h4>		
		<h5>STATUS : DEVELOPMENT</h5>
		<h5>LAST BUILD: #{UIMessages.project_maven_version}</h5>				
		</div>
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>					
		<br/>
		<br/>
		<br/>
		<br/>
		<br/>			
											
	</ui:define>
	
</ui:composition>

pmarlen-web/src/main/webapp/pages/home.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:richx="http://xpressosystems/richx"
                template="/templates/main.xhtml">

    <ui:define name="title">
		home
    </ui:define>

    <ui:define name="location">
        <h:outputText value="Operacion > Home" style="font-family: Arial;font-size : 10px;"/>
    </ui:define>

    <ui:define name="body">

        <br/>
        <br/>
        <br/>
        <h:outputText value="#{UIMessages.HOME_WELCOME_MESSAGE}"
                      styleClass="boldText" />
        <br/>
        <br/>
        <br/>
        <br/>
        <h:outputText value="sessionUserMB.testMessage = #{sessionUserMB.testMessage}"/>
        <br/>
        <br/>
        <br/>
        <a href="${facesContext.externalContext.requestContextPath}/clientApp/PerfumeriaMarlen_app-standard.jar">Instalador de Aplicacion</a>
        <br/>
        <br/>
    </ui:define>

</ui:composition>

pmarlen-web/src/main/webapp/pages/pedidoSimple.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                template="/templates/main.xhtml">

    <ui:define name="title">
		pedido simple
    </ui:define>

    <ui:define name="location">
        <h:outputText value="Operacion > Pedido Simple"  style="font-family: Arial;font-size : 10px;"/>
    </ui:define>

    <ui:define name="body">

        <a4j:form id="pedidoSearchForm" limitToList="searchPedidoSimpleTabPanel">

            <rich:tabPanel switchType="ajax" id="searchModeTabPane" selectedTab="#{pedidoSimpleMB.searchTabSelected}">
                <rich:tab label="Por Industria" id="industriaTab" >
                    <h:panelGrid columns="2" columnClasses="columnWidth30,columnWidth70" width="50%">
                        <h:outputText   value="Industria:"
                                        styleClass="littleLabel_bold_right"/>

                        <h:selectOneMenu value="#{pedidoSimpleMB.industriaSelected.id}"
                                         valueChangeListener="#{pedidoSimpleMB.industriaChanged}">
                            <f:selectItems value="#{pedidoSimpleMB.industriaList}"/>

                            <a4j:support reRender="pedidoSearchForm" event="onchange"/>
                        </h:selectOneMenu>

                        <h:outputText  value="Marca:" styleClass="littleLabel_bold_right" />
                        <h:selectOneMenu    id="searchByIndustriaMarca"
                                            value="#{pedidoSimpleMB.marcaSelected.id}"
                                            valueChangeListener="#{pedidoSimpleMB.marcaChanged}">

                            <f:selectItems  value="#{pedidoSimpleMB.marcaList}"/>

                            <a4j:support reRender="pedidoSearchForm" event="onchange"/>

                        </h:selectOneMenu>
                    </h:panelGrid>

                </rich:tab>

                <rich:tab label="Por Linea" id="lineaTab">
                    <h:panelGrid columns="2" columnClasses="columnWidth30,columnWidth70" width="50%">
                        <h:outputText   value="Linea:"
                                        styleClass="littleLabel_bold_right"/>

                        <h:selectOneMenu value="#{pedidoSimpleMB.lineaSelected.id}"
                                         valueChangeListener="#{pedidoSimpleMB.lineaChanged}">
                            <f:selectItems value="#{pedidoSimpleMB.lineaList}"/>

                            <a4j:support reRender="pedidoSearchForm" event="onchange"/>
                        </h:selectOneMenu>

                        <h:outputText  value="Marca:" styleClass="littleLabel_bold_right" />
                        <h:selectOneMenu    id="searchByLineaMarca"
                                            value="#{pedidoSimpleMB.marcaSelected.id}"
                                            valueChangeListener="#{pedidoSimpleMB.marcaChanged}">

                            <f:selectItems  value="#{pedidoSimpleMB.marcaList}"/>

                            <a4j:support reRender="pedidoSearchForm" event="onchange"/>

                        </h:selectOneMenu>
                    </h:panelGrid>

                </rich:tab>

            </rich:tabPanel>

            <h:panelGroup>
                <rich:messages layout="list" globalOnly="true">
                    <f:facet name="errorMarker">
                        <h:graphicImage  value="/images/error16x16.gif" />
                    </f:facet>
                </rich:messages>
            </h:panelGroup>

            <rich:dataGrid var="producto"
                           value="#{pedidoSimpleMB.productoList}" columns="5" width="100%"
                           rendered="#{not empty pedidoSimpleMB.marcaSelected.id }"
                           id="productoListDataGrid">
                <rich:panel>
                    <f:facet name="header">
                        <h:outputText value="Producto:"/>
                        <h:panelGroup >
                            <h:outputText value="#{producto.nombre}"/>
                        </h:panelGroup>
                    </f:facet>
                    <h:graphicImage value="/dynamicImages/Producto?id=#{producto.id}_160x120" />
                    <h:panelGrid columns="2" columnClasses="columnWidth30,columnWidth70">
                        <h:outputText  value="Presentacion:" styleClass="littleLabel_bold_right"/>
                        <h:outputText  value="#{producto.presentacion}" styleClass="common_font_littleComponent"/>
                    </h:panelGrid>
                </rich:panel>

            </rich:dataGrid>

        </a4j:form>


    </ui:define>

</ui:composition>

pmarlen-web/src/main/webapp/pages/productosEnAlmacenes.xhtml
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:richx="http://xpressosystems/richx"
                template="/templates/main.xhtml">

    <ui:define name="title">
		Productos en Almacenes
    </ui:define>

    <ui:define name="location">
        <h:outputText value="Administracion > Productos en Almacenes" style="font-family: Arial;font-size : 10px;"/>
    </ui:define>

    <ui:define name="body">

        <a4j:form id="productosEnAlmacenesForm">

            <h:panelGroup>
                <rich:messages layout="list" >
                    <f:facet name="errorMarker">
                        <h:graphicImage  value="/images/error16x16.gif" />
                    </f:facet>
                </rich:messages>
            </h:panelGroup>

			<h:panelGrid columns="2" styleClass="center" border="0"
						 columnClasses="columnWidth20,columnWidth80" >

                <h:outputText value="Sucursal : " styleClass="label_bold_right"/>

                <h:panelGroup style="display:block; text-align:left; background-color:transparent;">

                    <h:selectOneMenu id="sucursal"
									 value="#{operacionesEnAlmacenesMB.sucursalId}"
									 valueChangeListener="#{operacionesEnAlmacenesMB.sucursalChanged}"
                                     required="false">
                        <f:selectItems  value="#{operacionesEnAlmacenesMB.sucursales}"/>
						<a4j:support reRender="productosEnAlmacenesForm" event="onchange"/>
                    </h:selectOneMenu>

                </h:panelGroup>
			</h:panelGrid>


            <rich:dataTable id="productosEnAlmacenesTable"
							value="#{operacionesEnAlmacenesMB.allProductosEnTransitoDeSucursal}"
                            var="productoEnTrancito"
                            width="90%"
                            styleClass="center" columnClasses="columnWidth10,columnWidth50,columnWidth20,columnWidth20" >

                <f:facet name="header">
                    <h:panelGroup style="display:block; text-align:left; background-color:transparent;" >
                        <h:outputText value="Productos en Almacenes de Sucursal" />
                    </h:panelGroup>

                </f:facet>

                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="ID" />
                    </f:facet>
                    <h:panelGroup style="display:block; text-align:right; background-color:transparent;" >
                        <h:outputText value="#{productoEnTrancito.producto.id} [#{productoEnTrancito.producto.codigoBarras}]" />
                    </h:panelGroup>
                </rich:column>

                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="Producto" />
                    </f:facet>
                    <h:panelGroup style="display:block; text-align:left; background-color:transparent;" >
						<rich:panel  styleClass="tooltip-text" bodyClass="rich-laguna-panel-no-header">
							<!--
							  <h:graphicImage value="/dynamicImages/Producto?id=#{productoEnTrancito.producto.id}_20x15"/>
							-->
							<img src="/pmarlen-web/images/productos/ICO_PRODUCTO_#{productoEnTrancito.producto.id}.jpg"/>
                            <rich:spacer width="10"/>
                            <h:outputText value="#{productoEnTrancito.producto.nombre} / #{productoEnTrancito.producto.presentacion}"/>

                            <rich:toolTip showEvent="onclick" direction="bottom-left" mode="ajax" styleClass="tooltip" layout="block">

                                <f:facet name="defaultContent">
                                    <img src="/pmarlen-web/images/gif_loading_azul.gif"/>	     
                                </f:facet>

                                <h:panelGroup style="display:block; text-align:center; background-color:transparent;">

									<img src="/pmarlen-web/images/productos/MED_PRODUCTO_#{productoEnTrancito.producto.id}.jpg"/>
                                </h:panelGroup>

                            </rich:toolTip>
                        </rich:panel>

                    </h:panelGroup>
                </rich:column>

                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="Almacen Principal ($ A / T )" />
                    </f:facet>
					<h:panelGroup style="display:block; text-align:right; background-color:transparent;" >

						<h:outputText value="#{productoEnTrancito.principalPV}">
                            <f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
                        </h:outputText>
						<br/>
                        <h:outputText 	value="#{productoEnTrancito.principalActual}"/> /
						<h:outputText 	value="#{productoEnTrancito.principalEntrancito}"/> 
                    </h:panelGroup>					
				</rich:column>

                <rich:column>
                    <f:facet name="header">
                        <h:outputText value="Almacen Oportunidad ($ A / T )" />
                    </f:facet>

					<h:panelGroup style="display:block; text-align:right; background-color:transparent;" >
						<h:outputText value="#{productoEnTrancito.oportunidadPV}">
                            <f:convertNumber maxFractionDigits="2" pattern="$ ###,###,##0.00" locale="es_MX"/>
                        </h:outputText>
						<br/>
                        <h:outputText 	value="#{productoEnTrancito.oportunidadActual}"/> /
						<h:outputText 	value="#{productoEnTrancito.oportunidadEntrancito}"/> 
                    </h:panelGroup>
				</rich:column>

				<f:facet name="footer">
					
					<rich:datascroller	for="productosEnAlmacenesTable" maxPages="20"  
											page="#{operacionesEnAlmacenesMB.scrollerPage}" 
											id="productosEnAlmacenesTableScroller" />
				</f:facet>

            </rich:dataTable>

        </a4j:form>
    </ui:define>

</ui:composition>